(*$c+*)
PROGRAM string_test(input,output,prr,prd);
CONST z = '                               ';
VAR x : ARRAY[1 .. 32] OF CHAR;
    i : INTEGER;
    prr, prd : TEXT;
{Input and Output are predeclared Pascal text
 files.  In the original Portable Pascal system,
 prr and prd were also predeclared text files.
 In this system, they are not predeclared, but
 can be declared in ordinary Pascal fashion, as
 shown above. Note that this system now supports
 variable length string constants of up to 80
 characters.}
BEGIN
{Demonstrating how to declare external test files:
 In this implementation, the command line must have
 files with "prr" and "prd" AS A PART of their path-
 names. Thus, the command line files: a:\xxx\prr
 and c:y.prd will be interpreted by this system as
 valid "external" prr and prd files.
 Pascal external files are opened in C "r+" mode if
 they exist, else C "w+" mode.}
  REWRITE(prr); REWRITE(prd);
  WRITELN(prr,'PRR: 12345671234567');
  WRITELN(prd,'PRD: 1234567812345678');
  RESET(prr); RESET(prd);
  {NOTE THAT "x := z" BELOW IMPLIES MOVING A STRING
   CONSTANT INTO A PASCAL CHARACTER ARRAY:}
  x := z; i := 1;
  WHILE (i < 33) AND NOT EOLN(prr) DO
   BEGIN READ(prr, x[i]); i := i + 1 END;
  FOR i := 1 TO 32 DO WRITE(x[i]); WRITELN;
  x := z; i := 1;
  WHILE (i < 33) AND NOT EOLN(prd) DO
   BEGIN READ(prd, x[i]); i := i + 1 END;
  FOR i := 1 TO 32 DO WRITE(x[i]); WRITELN
END.
