echo off
echo Install PC-Project
echo *
if not "%1" == "" goto swoop
echo Usage:  INSTALL followed by drive letter, no colon.
echo         (With PC-Project system disk in default drive)
echo e.g.    "INSTALL B" would be used to make a floppy work disk.
echo         "INSTALL C" installs PC-Project on your hard disk.
goto end
:swoop
if "%1" == "a" goto floppy
if "%1" == "A" goto floppy
if "%1" == "b" goto floppy
if "%1" == "B" goto floppy
echo Install PC-Project on %1 drive
echo *
if exist %1:\pcp\pcproj.exe goto already
echo This procedure will create a directory on the %1 disk called \PCP.
echo It will then place all programs and necessary files in this 
echo directory.  Press ctrl-break to cancel installation.
pause
md %1:\pcp
cd %1:\pcp
goto merge
:already
echo This procedure will copy updated PC-Project files into your
echo %1:\pcp directory.  No harm will come to your own data files.
echo Press ctrl-break to cancel installation.
pause
cd %1:\pcp
goto merge
:floppy
echo Install PC-Project on a floppy disk.
echo To make a PC-Project work disk, you first need to FORMAT the disk.
yesno Have you already formatted your disk
echo *
if not ERRORLEVEL 1 goto skip1
echo Following instructions in your DOS documentation, format your new 
echo PC-Project work disk with the /s option, then put the PC-Project 
echo release disk back in drive A, and type "install %1" at the A prompt.
goto end
:skip1
echo Put newly formatted disk in drive %1.  Press ctrl-break to cancel.
pause
:merge
echo *
echo Installing program files
copy pcproj.exe %1:
copy pcproj.hlp %1:
copy sample %1:
copy form.doc %1:
copy readme.doc %1:
echo *
:bscreen
echo Installing screen drivers.  You will be asked what type of screen
echo you have.  There will be up to three questions.  Answer "Y" to the 
echo question that describes your system, "N" to any other questions.
echo The choices will be a) Monochrome or Hercules card, b) Color Graphics 
echo adapter, or c) Black and white (Compaq, for example).
echo *
yesno Do you have a Monochrome system 
if ERRORLEVEL 1 goto skip4
echo Installing MONO screen driver
copy mono.def %1:pcproj.def
goto escreen
:skip4
yesno Do you have a color system
if ERRORLEVEL 1 goto skip3
echo Installing COLOR screen driver
copy color.def %1:pcproj.def
goto escreen
:skip3
yesno Do you have a black and white system 
if ERRORLEVEL 1 goto skip2
echo Installing BW screen driver
copy bw.def %1:pcproj.def
goto escreen
:skip2
echo You only get 3 choices.  Pick one, and if it doesn't work, try again
goto bscreen
:escreen
echo *
echo The PC-Project manual is about 80 pages long.  If your printer is loaded
echo with at least 80 pages of continuous forms, you may print it now.
echo Print the manual by putting the PC-Project documentation disk in drive A 
echo and typing "COPY A:PCPROJ.DOC PRN".  Even if you don't need the manual, 
echo you should type "COPY A:FORM.DOC PRN" for a registration form and 
echo additional information not in the manual, if any (only 5 pages). 
echo *
if "%1" == "a" goto floppy2
if "%1" == "A" goto floppy2
if "%1" == "b" goto floppy2
if "%1" == "B" goto floppy2
echo To run PC-Project, type the following:
echo     %1:      (return)
echo     cd \pcp  (return) 
echo     pcproj   (return)
echo If you add "%1:\pcp;" to the path command in your autoexec.bat file
echo then you can forget about the first two steps above. 
goto bye
:floppy2
echo To run PC-Project, put your work disk, now in drive %1, in drive A,
echo then type the following:
echo     a:       (return)
echo     pcproj   (return)
:bye
echo *
echo One thing to remember:  You are encouraged to share PC-Project with
echo your friends.  When you do however, give them an exact copy of both the 
echo PC-Project system disk and the PC-Project documentation disk, not your 
echo work disk.  And please don't photocopy the printed manual.
echo *
echo Good luck with PC-Project, and thanks for supporting shareware.
:end



