echo off
rem COMPDOC.BAT - Batch file for printing the b_CRYPT SDF files
rem               that require compressed print.
cls
echo 
echo COMPDOC (tm), b_CRYPT (tm) Documentation Printing Batch File.
echo 
echo (C) Copr. 1988-89, Stephen B. Hajducek.  All rights reserved.
echo 
echo Check your printer attached to [%1] at this point before continuing,
echo 
echo if nothing appears between the brackets [] above, press control break
echo 
echo and enter printer device as prn or lpt1: or com1: etc on command line.
echo 
pause
cls
echo Now printing files...
if %1==prn goto start
if %1==lpt1: goto start
if %1==lpt2: goto start
if %1==lpt3: goto start
if %1==com1: goto start
if %1==com2: goto start
if %1==com3: goto start
goto error
:start
echo >%1
type b_crypt.cvr>%1
echo >%1
type p_order.frm>%1
echo >%1
type c_order.frm>%1
echo >%1
echo >%1
echo 
echo All files have been sent to printer...
goto end
:error
echo 
echo  ERROR: Incorrect command line parameters.
echo 
echo  At command line enter device for printing files in lower case:
echo 
echo  Example - compdoc prn:   'For default LPT1 printer.
echo            compdoc lpt2:  'For LPT2 parallel printer.
echo            compdoc com1:  'For COM1 attached serial printer.
:end
echo on
